<?php
/**
 * Imageloader Plugin
 *
 * @license		GNU/GPL
 */

// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );
require_once (dirname(__FILE__).DS.'helper.php');
require_once (dirname(__FILE__).DS.'thumb.php');

jimport( 'joomla.plugin.plugin' );
jimport( 'joomla.filesystem.file');
jimport( 'joomla.utilities.string');
jimport( 'joomla.language.helper');

/**
 * Imageloader Content Plugin
 *
 */
class plgContentImageloader extends JPlugin
{

	/**
	 * Constructor
	 *
	 */
	public function __construct(& $subject, $config)
	{
		parent::__construct( $subject, $config );
		$this->loadLanguage();
	}

	/**
	 * onContentPrepare
	 *
	 * Method is called by the view
	 *
	 * @param	string	The context of the content being passed to the plugin.
	 * @param	object	The article object.  Note $article->text is also available
	 * @param	object	The article params
	 * @param	int		The 'page' number
	 */
	function onContentPrepare( $context, &$article, &$params, $page=0 )
	{

		if (! preg_match_all( "/{\s*imageloader\s*.*?}/i", $article->text, $matches ))
		{
			return;
		}
		$count = count($matches[0]);

		if ($count)
		{
			$plugin			= JPluginHelper::getPlugin('content', 'imageloader');
			$pluginParams	= new JRegistry;
			$pluginParams->loadJSON( $plugin->params );

			for ($i = 0; $i < $count; $i++)
			{
				$match = str_replace( "&nbsp;", ' ', $matches[0][$i] );
				$match = preg_replace( '/{\s*imageloader\s*/i', '', $match );
				$match = str_replace( '}', '', $match );
				$match = trim( $match );
				$parray = array();
				while (preg_match( "/([ \t])*([A-Za-z0-9]*)([ \t])*=([ \t])*\"([^\"]+)\"/i", $match, $p ) > 0
					||preg_match( "/([ \t])*([A-Za-z0-9]*)([ \t])*=([ \t])*'([^']+)'/i", $match, $p ) > 0
					||preg_match( "/([ \t])*([A-Za-z0-9]*)([ \t])*=([ \t])*([^ ,]+)([ ,]*)/i", $match, $p ) > 0
					)
				{
					$parray[JString::strtolower($p[2])] = $p[5];
					$match = str_replace( $p[0], '', $match);
				}
				$paramArray = $pluginParams->toArray();
				$plgparams = new plgImageLoaderParams();
				$plgparams->init( $paramArray, $parray );
				$imageloadereroot	= JPATH_ROOT.DS.'plugins'.DS.'content'.DS.'imageloader'.DS;
				$helper = new plgImageLoaderHelper();
				$output = "";
				$images = $helper->getImages($article, $plgparams, $output );
				if ($images !== null)
				{
					$output = $this->doOutput( $article, $plgparams, $images, $helper );
				}
				$article->text = str_replace( $matches[0][$i], $output, $article->text );
			}
		}
	}
	function doOutput( &$article, &$params, &$images, &$helper )
	{
		$output = "";
		$group = $params->get('group','imageloader');
		$document = &JFactory::getDocument();
		$dflttmpl = '<a class="highslide {_hideclass}" id="{_anchorid}" href="{img}" title="{hreftitle}" onclick="return hs.expand(this,{slideshowGroup: \'{_group}\', captionText: \'{caption}\', thumbnailId: \'{_thumbid}\' })">'
		   .'<img class="imageloader_image" alt="{imgalt}" src="{_thumbimg}" title="{imgtitle}" id="{_id}" style="width: {_thumbwidth}px; height: {_thumbheight}px;{_styles}" /></a>';

		if ($params->get('outputtemplate') != '')
		{
			//
			//	load the template file
			//
			$outtmpl = $helper->getTemplate( $article, $params->get('outputtemplate') );
			if ($outtmpl != '')
			{
				$dflttmpl = $outtmpl;
			}
		}
		$inpage = $params->get('inpagegallery', "0");
		if ($inpage == '1')
		{
			$group = "gallery-area";
		}

		$dflttmpl .= "\n";

		$cssfile = $params->get('cssfile', 'plugins/content/imageloader/css/imageloader.css');
		$cssfile = $helper->resolvePathVars( $article, $cssfile );
		$cssfile = JURI::root(true).'/'.$cssfile;
		$thumbimg = JURI::root(true).'/plugins/content/imageloader/images/pixel.gif';
		$sharpenthumb = (int)$params->get('sharpenthumb','0');
		$sharpenthumb = max(min($sharpenthumb, 9), 0);
		$thumbdispwidth = (int)$params->get('thumbdisplaywidth',"0");
		$thumbdispheight = (int)$params->get('thumbdisplayheight',"0");

		jimport('joomla.environment.browser');
		$browser	= &JBrowser::getInstance();
		if ($browser->getBrowser() == "msie" && $browser->getMajor() <= 6)
		{
			$ie6css = JPATH_BASE.DS.'plugins'.DS.'content'.DS.'imageloader'.DS.'css'.DS.'imageloader-ie6.css';
			$ie6css = JPath::clean( $ie6css, DS );
			if (JFile::exists($ie6css))
			{
				$styledata = JFile::read($ie6css);
				$newtext = preg_replace( "/src=( )*'( )*([^' ]+)'/i", "src='" . JURI::root(true) . "\\3" . "'", $styledata );
				$document->addStyleDeclaration($newtext);
			}
		}

		if ( $params->get('cropthumb',"0") != 0
		   &&($thumbdispwidth != 0 || $thumbdispheight != 0)
		   )
		{
			$document->addScript( JURI::root(true).'/plugins/content/imageloader/js/imageloader-hs.js');
			$document->addScriptDeclaration( 'if (typeof hs  != "undefined") { hs.stripItemFormatter = imageLoaderHS; }' );
		}

		$document->addStyleSheet( $cssfile );
		$hideoption = $params->get('hideoption');

		if (!function_exists('imageconvolution'))
		{
			$sharpenthumb = 0;
		}

		if ($hideoption != "" && $inpage != "1")
		{
			if (is_numeric($hideoption) && (int)$hideoption < count($images))
			{
				$hidethumbid = (int)$hideoption;
			}
			else
			{
				foreach ($images as $i => $image)
				{
					if (isset($image['keywords']))
					{
						$kwdarr = explode( ',', $image['keywords']);
						for ($j = 0; $j<count($kwdarr); $j++)
						{
							if (JString::strcasecmp( JString::trim($kwdarr[$j]), $hideoption ) == 0
								&& !isset($hidethumbid)
								)
							{
								$hidethumbid = $i;
							}
						}
					}
				}
			}
		}
		$output .= 	"<div id=\"".$group."\" class=\"imageloader_images".$params->get('moduleclass_sfx')."\">\n";
		$maxcell = (is_numeric($params->get('cellcount')) ? (int)$params->get('cellcount') : 0);
		$maxrow = 0;
		if (isset($hidethumbid))
		{
			$maxcell = 0;
		}
		if ($maxcell > 0)
		{
			$tablehtml = $params->get('tablehtml', "cellspacing=\"4\"");
			$tbodyhtml = $params->get('tbodyhtml', "align=\"center\"" );
			$output .= "<table ".$tablehtml.">\n";
			$output .= "<tbody ".$tbodyhtml.">\n";
		}
		$cellcnt = 0;
		$base = JPATH_BASE;
		$base = JPath::clean( $base );
		for ($i=0; $i<count($images); $i++)
		{
			$thumbid = "";
			$hideclass = "";
			if (isset($hidethumbid))
			{
				if ($i != $hidethumbid)
				{
					$thumbid = $group."_image_".$hidethumbid;
					$hideclass = 'imageloader_hidden';
				}
			}
			if ($inpage == "1")
			{
				$hideclass = 'imageloader_hidden';
				if ($i != 0)
				{
					$thumbid = 'in-page-thumb1';
					$anchorid = $group."_anchor_".$i;
				}
				else
				{
					$anchorid = 'in-page-thumb1';
				}
			}
			else
			{
				$anchorid = $group."_anchor_".$i;
			}
			$imagename = $images[$i]['img'];
			$imagename = JPath::clean( JURI::root(true). '/'. $imagename, '/' );
			$dimagename = JPATH_BASE . DS . $images[$i]['img'];
			$dimagename = JPath::clean( $dimagename, DS );
			if (JFile::exists( $dimagename ))
			{
				$rflctparams['height'] = 0;
				$rflctparams['img'] = $dimagename;
				$thumbwidth = $params->get('thumbwidth', '20%');
				$rflctparams['resize'] = $thumbwidth;
				$thumbquality = $params->get('thumbquality', "90%" );
				$rflctparams['jpeg'] = $thumbquality;
				if ($params->get('phpmemorylimit') != '')
				{
					$rflctparams['memory_limit'] = $params->get('phpmemorylimit');
				}
				if ($params->get('phpmaxexectime') != '' && is_numeric($params->get('phpmaxexectime')))
				{
					$rflctparams['max_exec_time'] = $params->get('phpmaxexectime');
				}
				if ($sharpenthumb > 0)
				{
					$rflctparams['sharpen'] = $sharpenthumb;
				}
				$robj = new imageLoaderThumb();
				$rflctimage = $robj->create( $rflctparams );
				if ($rflctimage !== false)
				{
					$rflctimagename = $rflctimage;
					$rflctimage = JPath::clean( $rflctimage );
					if (JString::substr($rflctimage, 0, JString::strlen($base)) == $base)
					{
						$rflctimage = JString::substr( $rflctimage, JString::strlen($base), JString::strlen($rflctimage)-JString::strlen($base) );
					}
					$rflctimage = JPath::clean( JURI::root(true). '/'. $rflctimage, '/' );
				}
				else
				{
					$output .=  "<!-- Failed to generate thumbnail for image " . $rimagename . " -->\n";
				}
			}
			if ($rflctimage !== false)
			{
				$tmpl = $dflttmpl;
				if (isset( $images[$i]['tmplt'] ))
				{
					$tmpltoverride = $helper->getTemplate( $article, $images[$i]['tmplt'] );
					if ($tmpltoverride != "")
					{
						$tmpl = $tmpltoverride."\n";
					}
				}
				$dimginfo = getImageSize( $rflctimagename );
				$thumbdispwidth2 = ($thumbdispwidth == 0 ) ? $dimginfo[0] : $thumbdispwidth;
				$thumbdispheight2 = ($thumbdispheight == 0 ) ? $dimginfo[1] : $thumbdispheight;
				$def = JString::str_ireplace('{img}', $imagename, $tmpl );
				$def = JString::str_ireplace('{_thumbwidth}', $thumbdispwidth2, $def );
				$def = JString::str_ireplace('{_thumbheight}', $thumbdispheight2, $def );
				$def = JString::str_ireplace('{_thumbid}', $thumbid, $def );
				$def = JString::str_ireplace('{_thumb}', $rflctimage, $def );
				if ( $params->get('cropthumb',"0") == "0"
					||($thumbdispwidth == 0 && $thumbdispheight == 0)
					)
				{
					$thumbimg = $rflctimage;
					$styles = "";
				}
				else
				{
					$styles = " background-image: url('".$rflctimage."')";
				}
				$def = JString::str_ireplace('{_styles}', $styles, $def );
				$def = JString::str_ireplace('{_thumbimg}', $thumbimg, $def );
				if (isset($anchorid))
				{
					$def = JString::str_ireplace('{_anchorid}', $anchorid, $def );
				}
				$def = JString::str_ireplace('{_hideclass}', $hideclass, $def );
				foreach( $images[$i] as $kwd => $val)
				{
					$def = JString::str_ireplace('{'.$kwd.'}', $val, $def);
				}
				while ( preg_match( "/[{]([A-Za-z0-9_]*)[}]/i", $def, $match ) > 0)
				{
					$def = str_replace( $match[0], '', $def);
				}
				if ($maxcell > 0)
				{
					if ($cellcnt >= $maxcell)
					{
						$cellcnt = 0;
						$output .= "</tr>\n";
					}
					if ($cellcnt == 0)
					{
						$output .= "<tr>\n";
					}
					$output .= "<td>\n";
					$output .= $def;
					$output .= "</td>\n";
					$cellcnt++;
				}
				else
				{
					$output .= $def;
				}
			}
			else
			{
				$output .= "<!-- \n";
				$output .=  "Unable to find image " . $rimagename . " for display.\n";
				$output .=  "    Image:    ".$images[$i]['img']." \n";
				$output .=  "    Pathfile: ".$images[$i]['pathfile']." \n";
				$output .=  "    Pathbase: ".$images[$i]['pathbase']." \n";
				$output .=  " -->\n";
			}
		}
		if ($maxcell > 0)
		{
			$output .= "</tr>\n";
			$output .= "</tbody>\n";
			$output .= "</table>\n";
		}
		$output .= "</div>\n";
		return $output;
	}
}

class plgImageLoaderParams
{
	var $_params = array();

	function init( &$params1, &$params2 )
	{
		$this->_params = array_merge( $params1, $params2 );
	}

	function get( $name, $default = '' )
	{
		if (isset($this->_params[$name]))
		{
			return $this->_params[$name];
		}
		return $default;
	}
}
?>